require("love_reactor/all")
require("dialogs")
require("speechbubble")

Background = class({
  sprite = love.graphics.newImage("sprites/background.psd"),
  depth = 10000,
  offset = {
    x = 0, 
    y = 0
  }
}, {drawable})

Statler = class({
  sprite = love.graphics.newImage("sprites/statler.psd")
}, {drawable})

Waldorf = class({
  sprite = love.graphics.newImage("sprites/waldorf.psd")
}, {drawable})

function love.load()
  math.randomseed(love.timer.getTime())
  Background.new()

  Statler.new({
    x = 4 * love.window.getWidth() / 5,
    y = love.window.getHeight() - 200
  })

  Waldorf.new({
    x = 1 * love.window.getWidth() / 5,
    y = love.window.getHeight() - 200
  })

  local dialog = sequence(table.chain({""}, table.pick_random(dialogs), {"ha ha ha ha ha ha!!"}))

  local tween_done = make_stream()
  tween_done
    .delay(1)
    .take_until(dialog.done)
    .map(function()
      local text = dialog:next()
      local bubble = SpeechBubble.new({
        x = love.window.getWidth() / 2 - 300,
        y = (#SpeechBubble.instances.values() + 1) * (love.window.getHeight() / (#dialog._values + 1)),
        width = 600,
        text = ""
      })
      tween(bubble, "text", "", text, #text / 20, text_grow_interp, function() tween_done.send("adsf") end)
    end)

  dialog.done
    .map(function()
      keypressed_stream
        .map(function()
          love.event.quit()
        end)
    end)

  tween_done.send("asdf")

  love.audio.newSource("sfx/song2.mp3"):play()
end
